// • ▌ ▄ ·.  ▄▄▄·  ▄▄ • ▪   ▄▄· ▄▄▄▄·  ▄▄▄·  ▐▄▄▄  ▄▄▄ .
// ·██ ▐███▪▐█ ▀█ ▐█ ▀ ▪██ ▐█ ▌▪▐█ ▀█▪▐█ ▀█ •█▌ ▐█▐▌·
// ▐█ ▌▐▌▐█·▄█▀▀█ ▄█ ▀█▄▐█·██ ▄▄▐█▀▀█▄▄█▀▀█ ▐█▐ ▐▌▐▀▀▀
// ██ ██▌▐█▌▐█ ▪▐▌▐█▄▪▐█▐█▌▐███▌██▄▪▐█▐█ ▪▐▌██▐ █▌▐█▄▄▌
// ▀▀  █▪▀▀▀ ▀  ▀ ·▀▀▀▀ ▀▀▀·▀▀▀ ·▀▀▀▀  ▀  ▀ ▀▀  █▪ ▀▀▀
//      Magicbane Emulator Project © 2013 - 2022
//                www.magicbane.com


package engine.objects;

import engine.Enum;
import engine.InterestManagement.WorldGrid;
import engine.gameManager.*;
import engine.net.ByteBufferWriter;
import engine.net.client.msg.ErrorPopupMsg;
import engine.server.MBServerStatics;
import engine.workthreads.ZergMechanicThread;
import org.joda.time.DateTime;
import org.pmw.tinylog.Logger;

import java.net.UnknownHostException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Time;
import java.time.LocalDateTime;
import java.util.*;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ThreadLocalRandom;

import static engine.gameManager.DbManager.MineQueries;
import static engine.gameManager.DbManager.getObject;
import static engine.math.FastMath.sqr;

public class Mine extends AbstractGameObject {

    public static ConcurrentHashMap<Mine, Integer> mineMap = new ConcurrentHashMap<>(MBServerStatics.CHM_INIT_CAP, MBServerStatics.CHM_LOAD, MBServerStatics.CHM_THREAD_LOW);
    public static ConcurrentHashMap<Integer, Mine> towerMap = new ConcurrentHashMap<>(MBServerStatics.CHM_INIT_CAP, MBServerStatics.CHM_LOAD, MBServerStatics.CHM_THREAD_LOW);
    private String zoneName;
    private Zone parentZone;
    public boolean isActive = false;
    public PlayerCharacter lastClaimer;
    public boolean wasClaimed = false;
    // Not persisted to DB
    public String guildName;
    public GuildTag guildTag;
    public String nationName;
    public GuildTag nationTag;
    private Resource production;
    private Guild owningGuild;
    private int flags;
    private int buildingID;
    private MineProduction mineType;

    public int capSize;

    public final HashSet<Integer> _playerMemory = new HashSet<>();
    public final HashMap<Integer,Long> _recentMemory = new HashMap<>();
    public HashMap<Guild,ArrayList<Integer>> dividedPlayers;

    public boolean hasProduced = false;

    public int liveTime;
    public Boolean firstThirty = true;

    public static ArrayList<Mine> ChinaMines = new ArrayList<>();
    public static ArrayList<Mine> EuroMines = new ArrayList<>();
    public static ArrayList<Mine> AmericaMines = new ArrayList<>();

    public boolean wasOpened = false;
    /**
     * ResultSet Constructor
     */
    public Mine(ResultSet rs) throws SQLException, UnknownHostException {
        super(rs);

        this.mineType = MineProduction.getByName(rs.getString("mine_type"));
        //this.mineType = MineProduction.LUMBER;

        int ownerUID = rs.getInt("mine_ownerUID");
        this.buildingID = rs.getInt("mine_buildingUID");
        this.flags = rs.getInt("flags");
        //int parent = rs.getInt("parent");
        if(BuildingManager.getBuildingFromCache(rs.getInt("mine_buildingUID")) != null) {
            Building tower = BuildingManager.getBuildingFromCache(rs.getInt("mine_buildingUID"));

            for (Zone zone : ZoneManager.getAllZonesIn(tower.loc)) {
                if (zone.isMacroZone()) {
                    this.parentZone = zone;
                    this.zoneName = this.parentZone.getParent().getName();
                }
            }

            this.owningGuild = Guild.getGuild(ownerUID);
            Guild nation = null;

            if (this.owningGuild.isEmptyGuild()) {
                this.guildName = "";
                this.guildTag = GuildTag.ERRANT;
                nation = Guild.getErrantGuild();
                this.owningGuild = Guild.getErrantGuild();
            } else {
                this.guildName = this.owningGuild.getName();
                this.guildTag = this.owningGuild.getGuildTag();
                nation = this.owningGuild.getNation();
            }

            if (!nation.isEmptyGuild()) {
                this.nationName = nation.getName();
                this.nationTag = nation.getGuildTag();
            } else {
                this.nationName = "";
                this.nationTag = GuildTag.ERRANT;
            }

            this.production = Resource.valueOf(rs.getString("mine_resource"));
            this.lastClaimer = null;
        }
    }

    public static void SetTimes(){
        try {
            EuroMines.get(0).liveTime = 19;
            EuroMines.get(1).liveTime = 19;
            EuroMines.get(2).liveTime = 20;
            EuroMines.get(3).liveTime = 20;
            EuroMines.get(4).liveTime = 21;
            EuroMines.get(5).liveTime = 21;
            EuroMines.get(6).liveTime = 22;
        }catch(Exception e){

        }
        try{
            ChinaMines.get(0).liveTime = 11;
            ChinaMines.get(1).liveTime = 11;
            ChinaMines.get(2).liveTime = 11;
            ChinaMines.get(3).liveTime = 12;
            ChinaMines.get(4).liveTime = 12;
            ChinaMines.get(5).liveTime = 12;
            ChinaMines.get(6).liveTime = 12;
            ChinaMines.get(7).liveTime = 12;
            ChinaMines.get(8).liveTime = 12;
            ChinaMines.get(9).liveTime = 12;
            ChinaMines.get(10).liveTime = 13;
            ChinaMines.get(11).liveTime = 13;
            ChinaMines.get(12).liveTime = 13;
            ChinaMines.get(13).liveTime = 13;
        }catch(Exception e){

        }
        try{
            AmericaMines.get(0).liveTime = 1;
            AmericaMines.get(1).liveTime = 2;
            AmericaMines.get(2).liveTime = 2;
            AmericaMines.get(3).liveTime = 3;
            AmericaMines.get(4).liveTime = 3;
            AmericaMines.get(5).liveTime = 3;
            AmericaMines.get(6).liveTime = 3;
            AmericaMines.get(7).liveTime = 3;
            AmericaMines.get(8).liveTime = 3;
            AmericaMines.get(9).liveTime = 3;
            AmericaMines.get(10).liveTime = 4;
            AmericaMines.get(11).liveTime = 4;
            AmericaMines.get(12).liveTime = 4;
            AmericaMines.get(13).liveTime = 5;
        }catch(Exception e){

        }

        int count = 1;
        for(Mine mine : EuroMines){
            switch(count){
                case 1:
                    mine.capSize = 3;
                    break;
                case 2:
                    mine.capSize = 3;
                    break;
                case 3:
                    mine.capSize = 3;
                    break;
                case 4:
                    mine.capSize = 3;
                    break;
            }
            count ++;
            if(count == 5)
                count = 1;
            if(BuildingManager.getBuilding(mine.buildingID) != null) {
                Building mineTower = BuildingManager.getBuilding(mine.buildingID);
                if (mineTower != null) {
                    mineTower.setMaxHitPoints(5000 * mine.capSize);
                    mineTower.setCurrentHitPoints((float) 5000 * mine.capSize);
                }
            }
        }

        for(Mine mine : ChinaMines){
            switch(count){
                case 1:
                    mine.capSize = 3;
                    break;
                case 2:
                    mine.capSize = 5;
                    break;
                case 3:
                    mine.capSize = 5;
                    break;
                case 4:
                    mine.capSize = 3;
                    break;
            }
            count ++;
            if(count == 5)
                count = 1;

            if(BuildingManager.getBuilding(mine.buildingID) != null) {
                Building mineTower = BuildingManager.getBuilding(mine.buildingID);
                if (mineTower != null) {
                    mineTower.setMaxHitPoints(5000 * mine.capSize);
                    mineTower.setCurrentHitPoints((float) 5000 * mine.capSize);
                }
            }
        }

        for(Mine mine : AmericaMines){
            switch(count){
                case 1:
                    mine.capSize = 3;
                    break;
                case 2:
                    mine.capSize = 5;
                    break;
                case 3:
                    mine.capSize = 5;
                    break;
                case 4:
                    mine.capSize = 3;
                    break;
            }
            count ++;
            if(count == 5)
                count = 1;

            if(BuildingManager.getBuilding(mine.buildingID) != null) {
                Building mineTower = BuildingManager.getBuilding(mine.buildingID);
                if (mineTower != null) {
                    mineTower.setMaxHitPoints(5000 * mine.capSize);
                    mineTower.setCurrentHitPoints((float) 5000 * mine.capSize);
                }
            }
        }
    }
    public static void releaseMineClaims(PlayerCharacter playerCharacter) {

        if (playerCharacter == null)
            return;

        for (Mine mine : Mine.getMines()) {

            if (mine.lastClaimer != null)
                if (mine.lastClaimer.equals(playerCharacter)) {
                    mine.lastClaimer = null;
                    mine.updateGuildOwner(null);
                }

        }
    }

    public static void SendMineAttackMessage(Building mine) {

        if (mine.getBlueprint() == null)
            return;

        if (mine.getBlueprint().getBuildingGroup() != Enum.BuildingGroup.MINE)
            return;


        if (mine.getGuild().isEmptyGuild())
            return;

        if (mine.getGuild().getNation().isEmptyGuild())
            return;

        if (mine.getTimeStamp("MineAttack") > System.currentTimeMillis())
            return;

        mine.getTimestamps().put("MineAttack", System.currentTimeMillis() + MBServerStatics.ONE_MINUTE);

        ChatManager.chatNationInfo(mine.getGuild().getNation(), mine.getName() + " in " + mine.getParentZone().getParent().getName() + " is Under attack!");
    }

    public static void loadAllMines() {

        try {

            //Load mine resources
            MineProduction.addResources();

            //pre-load all building sets
            ArrayList<Mine> serverMines = MineQueries.GET_ALL_MINES_FOR_SERVER();

            for (Mine mine : serverMines) {
                Mine.mineMap.put(mine, mine.buildingID);
                Mine.towerMap.put(mine.buildingID, mine);
                //mine.mineType = MineProduction.LUMBER;
            }

            try {
                ChinaMines.add(serverMines.get(0));
                ChinaMines.add(serverMines.get(3));
                ChinaMines.add(serverMines.get(6));
                ChinaMines.add(serverMines.get(9));
                ChinaMines.add(serverMines.get(12));
                ChinaMines.add(serverMines.get(15));
                ChinaMines.add(serverMines.get(18));
                ChinaMines.add(serverMines.get(21));
                ChinaMines.add(serverMines.get(23));
                ChinaMines.add(serverMines.get(25));
                ChinaMines.add(serverMines.get(27));
                ChinaMines.add(serverMines.get(29));
                ChinaMines.add(serverMines.get(31));
                ChinaMines.add(serverMines.get(33));
            }catch(Exception e){

            }
            try{
                AmericaMines.add(serverMines.get(1));
                AmericaMines.add(serverMines.get(4));
                AmericaMines.add(serverMines.get(7));
                AmericaMines.add(serverMines.get(10));
                AmericaMines.add(serverMines.get(13));
                AmericaMines.add(serverMines.get(16));
                AmericaMines.add(serverMines.get(19));
                AmericaMines.add(serverMines.get(22));
                AmericaMines.add(serverMines.get(24));
                AmericaMines.add(serverMines.get(26));
                AmericaMines.add(serverMines.get(28));
                AmericaMines.add(serverMines.get(30));
                AmericaMines.add(serverMines.get(32));
                AmericaMines.add(serverMines.get(34));
            }catch(Exception e){

            }
            try{
                EuroMines.add(serverMines.get(2));
                EuroMines.add(serverMines.get(5));
                EuroMines.add(serverMines.get(8));
                EuroMines.add(serverMines.get(11));
                EuroMines.add(serverMines.get(14));
                EuroMines.add(serverMines.get(17));
                EuroMines.add(serverMines.get(20));
            }catch(Exception e){

            }


            SetTimes();
            for(Mine mine : EuroMines){
                if(EuroMines.indexOf(mine) %2 == 0 ){
                    mine.firstThirty = true;
                } else{
                    mine.firstThirty = false;
                }
            }
            for(Mine mine : AmericaMines){
                if(AmericaMines.indexOf(mine) %2 == 0 ){
                    mine.firstThirty = true;
                } else{
                    mine.firstThirty = false;
                }
            }
            for(Mine mine : ChinaMines){
                if(ChinaMines.indexOf(mine) %2 == 0 ){
                    mine.firstThirty = true;
                } else{
                    mine.firstThirty = false;
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        for(Mine mine : Mine.getMines()){
            int minute = 0;
            if (mine.firstThirty == false)
                minute = 30;
            LocalDateTime openTime = LocalDateTime.now().withHour(mine.liveTime).withMinute(minute).withSecond(0);
            LocalDateTime closeTime = openTime.plusMinutes(30);
            if(LocalDateTime.now().isAfter(closeTime))
                mine.wasOpened = true;
        }
    }

    /*
     * Getters
     */

    public static Mine getMineFromTower(int towerID) {
        return Mine.towerMap.get(towerID);
    }

    public static void serializeForClientMsg(Mine mine, ByteBufferWriter writer) {
        writer.putInt(mine.getObjectType().ordinal());
        writer.putInt(mine.getObjectUUID());
        writer.putInt(mine.getObjectUUID()); //actually a hash of mine
        writer.putString(mine.mineType.name);
        if(ChinaMines.contains((mine))) {
            writer.putString("Chinese" + " {" + mine.capSize + " Man}");
        } else if(AmericaMines.contains(mine)){
            writer.putString("American" + " {" + mine.capSize + " Man}");
        } else if(EuroMines.contains(mine)){
            writer.putString("European" + " {" + mine.capSize + " Man}");
        }else{
            writer.putString("Unknown" + " {" + mine.capSize + " Man}");
        }
        writer.putInt(mine.production.hash);
        writer.putInt(mine.getModifiedProductionAmount());
        writer.putInt(mine.getModifiedProductionAmount()); //TODO calculate range penalty here
        writer.putInt(3600); //window in seconds //production per hour in seconds?

        // Errant mines are currently open.  Set time to now.

        LocalDateTime mineOpenTime;// = LocalDateTime.now().withMinute(0).withSecond(0).withNano(0);
        if(mine.firstThirty == true){
            mineOpenTime = LocalDateTime.now().withHour(mine.liveTime).withMinute(0).withSecond(0).withNano(0);
        }
        else{
            mineOpenTime = LocalDateTime.now().withHour(mine.liveTime).withMinute(30).withSecond(0).withNano(0);
        }

        LocalDateTime mineCloseTime = mineOpenTime.plusMinutes(30);
        if(LocalDateTime.now().isAfter(mineCloseTime)){
            mineOpenTime = mineOpenTime.plusDays(1);
            mineCloseTime = mineCloseTime.plusDays(1);
        }
        writer.putLocalDateTime(mineOpenTime);
        writer.putLocalDateTime(mineCloseTime);
        writer.put(mine.isActive ? (byte) 0x01 : (byte) 0x00);

        Building mineTower = BuildingManager.getBuilding(mine.buildingID);
        writer.putFloat(mineTower.getLoc().x);
        writer.putFloat(mineTower.getParentZone().getLoc().y);
        writer.putFloat(mineTower.getLoc().z);

        writer.putInt(mine.isExpansion() ? mine.mineType.xpacHash : mine.mineType.hash);

        writer.putString(mine.guildName);
        GuildTag._serializeForDisplay(mine.guildTag, writer);
        writer.putString(mine.nationName);
        GuildTag._serializeForDisplay(mine.nationTag, writer);
    }

    public static ArrayList<Mine> getMinesForGuild(int guildID) {

        ArrayList<Mine> mineList = new ArrayList<>();

        // Only inactive mines are returned.

        for (Mine mine : Mine.mineMap.keySet()) {
            if (mine.owningGuild.getObjectUUID() == guildID &&
                    mine.isActive == false)
                mineList.add(mine);
        }
        return mineList;
    }

    /*
     * Database
     */
    public static Mine getMine(int UID) {
        return MineQueries.GET_MINE(UID);

    }

    public static ArrayList<Mine> getMines() {
        return new ArrayList<>(mineMap.keySet());
    }

    public static boolean validateClaimer(PlayerCharacter playerCharacter) {

        // Method validates that the claimer meets
        // all the requirements to claim; landed
        // guild with a warehouse, etc.

        Guild playerGuild;

        //verify the player exists

        if (playerCharacter == null)
            return false;

        //verify the player is in valid guild

        playerGuild = playerCharacter.getGuild();

        // Can't claim something if you don't have a guild!

        if (playerGuild.isEmptyGuild())
            return false;

        if (playerGuild.getNation().isEmptyGuild())
            return false;

        // Guild must own a city to hold a mine.

        City guildCity = playerGuild.getOwnedCity();

        if (guildCity == null)
            return false;

        if (guildCity.getWarehouse() == null) {
            ErrorPopupMsg.sendErrorMsg(playerCharacter, "No Warehouse exists for this claim.");
            return false;
        }

        // Number of mines is based on the rank of the nation's tree.

        City nationCapitol = playerGuild.getNation().getOwnedCity();

        Building nationCapitolTOL = nationCapitol.getTOL();

        if (nationCapitolTOL == null)
            return false;

        //int treeRank = nationCapitolTOL.getRank();

        //if (treeRank < 1)
        //    return false;

        //if (guildUnderMineLimit(playerGuild.getNation(), treeRank) == false) {
        //    ErrorPopupMsg.sendErrorMsg(playerCharacter, "Your nation cannot support another mine.");
        //    return false;
        //}

        return true;
    }

    private static boolean guildUnderMineLimit(Guild playerGuild, int tolRank) {

        int mineCnt = 0;

        mineCnt += Mine.getMinesForGuild(playerGuild.getObjectUUID()).size();

        for (Guild guild : playerGuild.getSubGuildList())
            mineCnt += Mine.getMinesForGuild(guild.getObjectUUID()).size();

        return mineCnt <= tolRank;
    }

    public boolean changeProductionType(Resource resource) {
        //if (!this.validForMine(resource))
        //    return false;
        //update resource in database;
        if (!MineQueries.CHANGE_RESOURCE(this, resource))
            return false;

        if(this.isActive || this.hasProduced)
            return false;

        this.production = resource;
        this.hasProduced = true;
        ItemBase resourceIB = ItemBase.getItemBase(this.production.UUID);

        return this.owningGuild.getOwnedCity().getWarehouse().depositFromMine(this, resourceIB, this.getModifiedProductionAmount());
    }

    public MineProduction getMineType() {
        return this.mineType;
    }

    public void setMineType(String type) {
        this.mineType = MineProduction.getByName(type);
    }

    public String getZoneName() {
        return this.zoneName;
    }

    public Resource getProduction() {
        return this.production;
    }

    public boolean getIsActive() {
        return this.isActive;
    }

    public Guild getOwningGuild() {
        if (this.owningGuild == null)
            return Guild.getErrantGuild();
        else
            return this.owningGuild;
    }

    public void setOwningGuild(Guild owningGuild) {
        this.owningGuild = owningGuild;
    }

    /*
     * Serialization
     */

    public int getFlags() {
        return flags;
    }

    public void setFlags(int flags) {
        this.flags = flags;
    }

    public Zone getParentZone() {
        return parentZone;
    }

    public GuildTag getGuildTag() {
        return guildTag;
    }

    public void setActive(boolean isAc) {

        this.isActive = isAc;
        Building building = BuildingManager.getBuildingFromCache(this.buildingID);
        if (building != null && !this.isActive)
            building.isDeranking.compareAndSet(true, false);

        if(isAc) {
            ZergMechanicThread.startZergThreadMine(this);
        }

        this.wasOpened = true;
    }

    public boolean validForMine(Resource r) {
        if (this.mineType == null)
            return false;
        return this.mineType.validForMine(r, this.isExpansion());
    }

    public void serializeForMineProduction(ByteBufferWriter writer) {
        writer.putInt(this.getObjectType().ordinal());
        writer.putInt(this.getObjectUUID());
        writer.putInt(this.getObjectUUID()); //actually a hash of mine
        //		writer.putInt(0x215C92BB); //this.unknown1);
        writer.putString(this.mineType.name);
        writer.putString(this.zoneName);
        writer.putInt(this.production.hash);
        writer.putInt(this.production.baseProduction);
        writer.putInt(this.getModifiedProductionAmount()); //TODO calculate range penalty here
        writer.putInt(3600); //window in seconds
        writer.putInt(this.isExpansion() ? this.mineType.xpacHash : this.mineType.hash);
    }

    @Override
    public void updateDatabase() {
        // TODO Create update logic.
    }

    public int getBuildingID() {
        return buildingID;
    }

    public void setBuildingID(int buildingID) {
        this.buildingID = buildingID;
    }

    public void handleDestroyMine() {

        if (!this.isActive)
            return;

        //remove tags from mine

        this.guildName = "";
        this.nationName = "";
        this.owningGuild = Guild.getErrantGuild();
        this.lastClaimer = null;
        this.wasClaimed = false;
        this.hasProduced = false;
        // Update database

        DbManager.MineQueries.CHANGE_OWNER(this, 0);

        // Update mesh

        Building mineBuilding = BuildingManager.getBuildingFromCache(this.buildingID);

        if (mineBuilding == null) {
            Logger.debug("Null mine building " + this.getObjectUUID() + ". Unable to Load Building with UID " + this.buildingID);
            return;
        }

        mineBuilding.setOwner(null);
        mineBuilding.refresh(false);

        // remove hirelings

        Building building = (Building) getObject(Enum.GameObjectType.Building, this.buildingID);
        BuildingManager.cleanupHirelings(building);
    }

    public boolean claimMine(PlayerCharacter claimer) {

        if (claimer == null)
            return false;

        if (!validateClaimer(claimer))
            return false;

        if (!this.isActive) {
            ErrorPopupMsg.sendErrorMsg(claimer, "Can not for to claim inactive mine.");
            return false;
        }

        if (!updateGuildOwner(claimer))
            return false;

        // Successful claim

        this.lastClaimer = claimer;

        return true;
    }

    public boolean depositMineResources() {

        if (this.owningGuild.isEmptyGuild())
            return false;

        if (this.owningGuild.getOwnedCity() == null)
            return false;

        if (this.owningGuild.getOwnedCity().getWarehouse() == null)
            return false;

        ItemBase resourceIB = ItemBase.getItemBase(this.production.UUID);
        return this.owningGuild.getOwnedCity().getWarehouse().depositFromMine(this, resourceIB, this.getModifiedProductionAmount());
    }

    public boolean updateGuildOwner(PlayerCharacter playerCharacter) {

        Building mineBuilding = BuildingManager.getBuildingFromCache(this.buildingID);

        //should never return null, but let's check just in case.

        if (mineBuilding == null) {
            ChatManager.chatSystemError(playerCharacter, "Unable to find mine tower.");
            Logger.debug("Failed to Update Mine with UID " + this.getObjectUUID() + ". Unable to Load Building with UID " + this.buildingID);
            return false;
        }

        if (playerCharacter == null) {
            this.owningGuild = Guild.getErrantGuild();
            this.guildName = "None";
            this.guildTag = GuildTag.ERRANT;
            this.nationName = "None";
            this.nationTag = GuildTag.ERRANT;
            //Update Building.
            mineBuilding.setOwner(null);
            WorldGrid.updateObject(mineBuilding);
            return true;
        }

        Guild guild = playerCharacter.getGuild();

        if (guild.getOwnedCity() == null)
            return false;

        if (!MineQueries.CHANGE_OWNER(this, guild.getObjectUUID())) {
            Logger.debug("Database failed to Change Ownership of Mine with UID " + this.getObjectUUID());
            ChatManager.chatSystemError(playerCharacter, "Failed to claim Mine.");
            return false;
        }

        //update mine.
        this.owningGuild = guild;

        //Update Building.
        PlayerCharacter guildLeader = (PlayerCharacter) Guild.GetGL(this.owningGuild);

        if (guildLeader != null)
            mineBuilding.setOwner(guildLeader);
        WorldGrid.updateObject(mineBuilding);
        return true;
    }

    public boolean isExpansion() {
        return true;
    }

    public int getModifiedProductionAmount() {
        int value = Warehouse.getCostForResource(this.production.UUID);
        int amount = 0;
        switch(this.capSize){
            case 3:
                amount = 1800000;
                break;
            case 5:
                amount = 3000000;
                break;
            case 10:
                amount = 6000000;
                break;
            case 20:
                amount = 12000000;
                break;
        }
        if(this.production.UUID == 7)
            amount *= 0.5f;
        else
            amount = amount / value;
        return (int) amount;
    }
    public Boolean onExit(HashSet<AbstractWorldObject> currentPlayers){
        ArrayList<Integer> purge = new ArrayList<>();
        for(int id : this._playerMemory){
            PlayerCharacter player = PlayerCharacter.getPlayerCharacter(id);
            if(!currentPlayers.contains(player)){
                purge.add(id);
                player.ZergMultiplier = 1.0f;
                //ChatManager.chatSystemInfo(player,"Left Mine, Multiplier: " + player.ZergMultiplier);
            }
        }

        if(purge.size() > 0) {
            //this._playerMemory.removeAll(purge);
            for(int id : purge){
                if(!this._recentMemory.containsKey(id)) {
                    this._recentMemory.put(id, System.currentTimeMillis() + 60000);
                } else if(this._recentMemory.get(id) > System.currentTimeMillis()){
                    this._playerMemory.remove(id);
                    //ChatManager.chatSystemInfo(PlayerCharacter.getPlayerCharacter(id),"Left Have Been Removed from The Mine List");
                }
            }
        }
        return true;
    }
}
